#include "calendar.h"

short DateCalc(short year, short mon, short *daysPtr, unsigned short *nydPtr)
{
    short days = *daysPtr = 0;
    short prev_yr = year - 1;
    unsigned short nyd = *nydPtr = 0;
    double rnd_y = ((year - 2000) / 4.0 + 0.5);
    unsigned char leap_yr = FALSE;

    if (year > 2001) {
        /* determine which weekday is New Year's Day for given year; values are
         * relative to Mon, Jan 1, 2001 (== 1); the max allowable is 6 (i.e.
         * Sat, Jan 1); when Jan 1 is Sun., no days are skipped when printing
         * the calendar (i.e. the value of 'gap' is 0) */
        nyd = (unsigned short)(-1 + (year - 2000) + rnd_y) % 7;

        if (year % 400 == 0 || (year % 4 == 0 && year % 100 != 0))
            leap_yr = TRUE;

        if (prev_yr % 400 == 0 || (prev_yr % 4 == 0 && prev_yr % 100 != 0))
            /* after a leapyear, New Year's Day will always be two days later
             * than the prev yr; 2001 would test TRUE but is not included b/c
             * Jan. 1, 2001 is the ref pt for the above calculation */
            nyd++;

        if (nyd > 6) /* filter unacceptable values that may result from above
                        'rounding' scheme */
            nyd = 0;
    }
    else
        nyd = 1; /* Mon, Jan 1, 2001 */

    switch (mon) {
    case 2:
        if (!leap_yr) {
            days = 28;
            break;
        }
        else { /* leapyear */
            days = 29;
            break;
        }
    case 4:
    case 6:
    case 9:
    case 11:
        days = 30;
        break;
    default:
        days = 31;
    }

    *daysPtr = days;
    *nydPtr = nyd;

    return GetGap(year, mon, nyd);
}
