#include "calendar.h"

/** @remarks While New Year's Day is coded 1(Mon.)-6(Sat.) releative to # of
 * years after 2001(==1), weekdays are coded 0-6 for Sun. - Sat.; starting
 * with Feb. 1, the starting weekday of every month is coded according to a
 * set pattern */
short GetGap(const short year, const short mon, const unsigned short nyd)
{
    short gap = 0;

    switch (nyd) { /* evaluates which weekday is Jan. 1 */
    case 0:
        switch (mon) { /* evaluates first day of each following month */
        case 2:
        case 3:
            gap = 3;
            break;
        case 4:
            gap = 6;
            break;
        case 5:
            gap = 1;
            break;
        case 6:
            gap = 4;
            break;
        case 7:
            gap = 6;
            break;
        case 8:
            gap = 2;
            break;
        case 9:
            gap = 5;
            break;
        case 10:
            gap = 0;
            break;
        case 11:
            gap = 3;
            break;
        case 12:
            gap = 5;
            break;
        default:
            gap = 0; /* Sun, Jan. 1 */
            break;
        }
        break;
    case 1:
        switch (mon) {
        case 2:
        case 3:
            gap = 4;
            break;
        case 4:
            gap = 0;
            break;
        case 5:
            gap = 2;
            break;
        case 6:
            gap = 5;
            break;
        case 7:
            gap = 0;
            break;
        case 8:
            gap = 3;
            break;
        case 9:
            gap = 6;
            break;
        case 10:
            gap = 1;
            break;
        case 11:
            gap = 4;
            break;
        case 12:
            gap = 6;
            break;
        default:
            gap = 1; /* Mon, Jan. 1 */
            break;
        }
        break;
    case 2:
        switch (mon) {
        case 2:
        case 3:
            gap = 5;
            break;
        case 4:
            gap = 1;
            break;
        case 5:
            gap = 3;
            break;
        case 6:
            gap = 6;
            break;
        case 7:
            gap = 1;
            break;
        case 8:
            gap = 4;
            break;
        case 9:
            gap = 0;
            break;
        case 10:
            gap = 2;
            break;
        case 11:
            gap = 5;
            break;
        case 12:
            gap = 0;
            break;
        default:
            gap = 2; /*Tues, Jan. 1 */
            break;
        }
        break;
    case 3:
        switch (mon) {
        case 2:
        case 3:
            gap = 6;
            break;
        case 4:
            gap = 2;
            break;
        case 5:
            gap = 4;
            break;
        case 6:
            gap = 0;
            break;
        case 7:
            gap = 2;
            break;
        case 8:
            gap = 5;
            break;
        case 9:
            gap = 1;
            break;
        case 10:
            gap = 3;
            break;
        case 11:
            gap = 6;
            break;
        case 12:
            gap = 1;
            break;
        default:
            gap = 3; /*Wednes, Jan. 1 */
            break;
        }
        break;
    case 4:
        switch (mon) {
        case 2:
        case 3:
            gap = 0;
            break;
        case 4:
            gap = 3;
            break;
        case 5:
            gap = 5;
            break;
        case 6:
            gap = 1;
            break;
        case 7:
            gap = 3;
            break;
        case 8:
            gap = 6;
            break;
        case 9:
            gap = 2;
            break;
        case 10:
            gap = 4;
            break;
        case 11:
            gap = 0;
            break;
        case 12:
            gap = 2;
            break;
        default:
            gap = 4; /*Thurs, Jan. 1 */
            break;
        }
        break;
    case 5:
        switch (mon) {
        case 2:
        case 3:
            gap = 1;
            break;
        case 4:
            gap = 4;
            break;
        case 5:
            gap = 6;
            break;
        case 6:
            gap = 2;
            break;
        case 7:
            gap = 4;
            break;
        case 8:
            gap = 0;
            break;
        case 9:
            gap = 3;
            break;
        case 10:
            gap = 5;
            break;
        case 11:
            gap = 1;
            break;
        case 12:
            gap = 3;
            break;
        default:
            gap = 5; /*Fri, Jan. 1 */
            break;
        }
        break;
    case 6:
        switch (mon) {
        case 2:
        case 3:
            gap = 2;
            break;
        case 4:
            gap = 5;
            break;
        case 5:
            gap = 0;
            break;
        case 6:
            gap = 3;
            break;
        case 7:
            gap = 5;
            break;
        case 8:
            gap = 1;
            break;
        case 9:
            gap = 4;
            break;
        case 10:
            gap = 6;
            break;
        case 11:
            gap = 2;
            break;
        case 12:
            gap = 4;
            break;
        default:
            gap = 6; /* Sat, Jan. 1 */
            break;
        }
        break;
    }
    
    /* in a leapyear, the first of every month will be one day later than the
     * prev yr, from Mar. 1 onward */
    if (mon >= 3 && year % 4 == 0)
        gap++;
        
    /* keep adjusted date codes with predefined bounds */
    if (gap > 6)
        gap = 0;

    return (gap);
}
